#include "sorting.h"

const char *sortname = "Merge Sort";

static void merge(int p[], int left, int right)
{
    int h = (left + right) / 2;
    int i, px = left, qx = h+1;
    int width = right - left + 1;
    int b[width];

    for (i = 0; i < width; i++) {
        int flag = 1;
        if (qx <= right) {
            if (px > h)
                flag = 0;
            else {
                count++;
                if (p[px] > p[qx])
                    flag = 0;
            }
        }
        b[i] = flag ? p[px++] : p[qx++];
    }
    for (i = 0, px = left; i < width; i++, px++) {
        p[px] = b[i];
        replaced(p, px);
    }
}

static void msort(int p[], int left, int right)
{
    if (left < right) {
        int h = (left + right) / 2;
        msort(p, left, h);
        msort(p, h+1, right);
        merge(p, left, right);
    }
}

void sort(int a[], int n) {
    msort(a, 0, n-1);
}
